#!/sbin/sh

ANDROID_VERSION=$(grep version.release /system/build.prop)
BOOTLOADER=$(getprop ro.boot.bootloader | rev | cut -c1-4 | rev)
ROM_BUILD=$(grep version.incremental /system/build.prop | rev | cut -c1-4 | rev)
grep ro.boot.bootloader=.* /cache/recovery/log | cut -d "=" -f2 &> /tmp/BLmodel

if [[ $BOOTLOADER \> $ROM_BUILD ]]; then
ROM_BUILD=$BOOTLOADER
fi

CAMERA_BUILD3=CRC1
CAMERA_BUILD2=BQJ1
CAMERA_BUILD1=BQJ0

# BACKUP
if [ ! -f /data/misc/media_profiles.bak ]; then
  cp -a /system/etc/media_profiles.xml /data/misc/media_profiles.bak
fi

if [ ! -f /data/misc/camera-feature-v7.bak ]; then
  cp -a /system/cameradata/camera-feature-v7.xml /data/misc/camera-feature-v7.bak
fi

if [ ! -f /data/misc/SamsungCamera7.bak ]; then
  cp -a /system/priv-app/SamsungCamera7/SamsungCamera7.apk /data/misc/SamsungCamera7.bak
fi

mv /system/priv-app/SamsungCamera7/oat /system/priv-app/SamsungCamera7/oatbak


cp -a /tmp/media_profiles.xml /system/etc/media_profiles.xml

#Removes Super Slow Motion for roms < CRI5
if [[ $ROM_BUILD \< "CRH3" ]]; then
	sed -i '/SHOOTINGMODE_SUPER_SLOW_MOTION/d' /tmp/camera-feature-v7_N8_exynos.xml
	sed -i '/SHOOTINGMODE_SUPER_SLOW_MOTION/d' /tmp/camera-feature-v7_N8_snapdragon.xml
fi

if [ -f /system/lib/libexynoscamera.so ]; then
	
	if grep -q N95 /tmp/BLmodel; then
		cp -a /tmp/camera-feature-v7_N8_exynos.xml /system/cameradata/camera-feature-v7.xml
	fi
	
	if [[ $ROM_BUILD \> $CAMERA_BUILD3 || $ROM_BUILD == $CAMERA_BUILD3 ]]; then
		cp -a /tmp/SamsungCamera7_exynos_7614.apk /system/priv-app/SamsungCamera7/SamsungCamera7.apk
	else if [[ $ROM_BUILD \> $CAMERA_BUILD2 || $ROM_BUILD == $CAMERA_BUILD2 ]]; then
		cp -a /tmp/SamsungCamera7_exynos_7556.apk /system/priv-app/SamsungCamera7/SamsungCamera7.apk
	else
		cp -a /tmp/SamsungCamera7_exynos_7546.apk /system/priv-app/SamsungCamera7/SamsungCamera7.apk
	fi
	fi		
else

	if grep -q N95 /tmp/BLmodel; then
	  cp -a /tmp/camera-feature-v7_N8_snapdragon.xml /system/cameradata/camera-feature-v7.xml
	fi
	
	if [[ $ROM_BUILD \> $CAMERA_BUILD3 || $ROM_BUILD == $CAMERA_BUILD3 ]]; then
		cp -a /tmp/SamsungCamera7_snapdragon_7614.apk /system/priv-app/SamsungCamera7/SamsungCamera7.apk
	else if [[ $ROM_BUILD \> $CAMERA_BUILD2 || $ROM_BUILD == $CAMERA_BUILD2 ]]; then
		cp -a /tmp/SamsungCamera7_snapdragon_7556.apk /system/priv-app/SamsungCamera7/SamsungCamera7.apk
	else
		cp -a /tmp/SamsungCamera7_snapdragon_7546.apk /system/priv-app/SamsungCamera7/SamsungCamera7.apk
	fi
	fi		
	
fi 

if [ -f /data/dalvik-cache/arm64/system@priv-app@SamsungCamera7@SamsungCamera7.apk@classes.dex ]; then
  rm /data/dalvik-cache/arm64/system@priv-app@SamsungCamera7@SamsungCamera7.apk@classes.dex
fi

if [ -f /data/dalvik-cache/arm64/system@priv-app@SamsungCamera7@SamsungCamera7.apk@classes.art ]; then
  rm /data/dalvik-cache/arm64/system@priv-app@SamsungCamera7@SamsungCamera7.apk@classes.art
fi

rm -r /data/data/com.sec.android.app.camera
